import { ISensor, LocateEvent, ScrollTarget, IScrollable, DropLocation } from '@alilc/lowcode-designer';
import { IEditor } from '@alilc/lowcode-types';
import TreeNode from './tree-node';
import { ITreeBoard, TreeMaster } from './tree-master';
export declare class OutlineMain implements ISensor, ITreeBoard, IScrollable {
    private _designer?;
    private _master?;
    get master(): TreeMaster;
    get currentTree(): import("./tree").Tree;
    readonly id: string;
    _visible: boolean;
    get visible(): boolean;
    readonly editor: IEditor;
    readonly at: string | symbol;
    constructor(editor: IEditor, at: string | symbol);
    /**
     * @see ISensor
     */
    fixEvent(e: LocateEvent): LocateEvent;
    private indentTrack;
    private dwell;
    /**
     * @see ISensor
     */
    locate(e: LocateEvent): DropLocation | undefined | null;
    private getNear;
    private drillLocate;
    /**
     * @see ISensor
     */
    isEnter(e: LocateEvent): boolean;
    private tryScrollAgain;
    /**
     * @see IScrollBoard
     */
    scrollToNode(treeNode: TreeNode, detail?: any, tryTimes?: number): void;
    private sensing;
    /**
     * @see ISensor
     */
    deactiveSensor(): void;
    /**
     * @see IScrollable
     */
    get bounds(): DOMRect | null;
    private _scrollTarget?;
    /**
     * @see IScrollable
     */
    get scrollTarget(): ScrollTarget;
    private scroller?;
    private setupDesigner;
    purge(): void;
    private _sensorAvailable;
    /**
     * @see ISensor
     */
    get sensorAvailable(): boolean;
    private _shell;
    mount(shell: HTMLDivElement | null): void;
    private getInsertionRect;
    private getTreeNodeRect;
    private getTreeTitleRect;
    private getTreeSlotsRect;
}
