import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _createClass from "@babel/runtime/helpers/createClass";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _dec2, _class, _descriptor, _descriptor2;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { computed, makeObservable, obx } from '@alilc/lowcode-editor-core';
import { isDragNodeObject, isDragAnyObject, ScrollTarget, isLocationChildrenDetail, LocationDetailType, contains } from '@alilc/lowcode-designer';
import { uniqueId } from '@alilc/lowcode-utils';
import { IndentTrack } from './helper/indent-track';
import DwellTimer from './helper/dwell-timer';
import { Backup } from './views/backup-pane';
import { getTreeMaster } from './tree-master';
export var OutlineMain = (_dec = obx.ref, _dec2 = obx.ref, (_class = /*#__PURE__*/function () {
  function OutlineMain(editor, at) {
    var _this = this;

    this._designer = void 0;

    _initializerDefineProperty(this, "_master", _descriptor, this);

    this.id = uniqueId('outline');

    _initializerDefineProperty(this, "_visible", _descriptor2, this);

    this.editor = void 0;
    this.at = void 0;
    this.indentTrack = new IndentTrack();
    this.dwell = new DwellTimer(function (target, event) {
      var document = target.document;
      var designer = document.designer;
      var index;
      var focus;
      var valid = true;

      if (target.hasSlots()) {
        index = null;
        focus = {
          type: 'slots'
        };
      } else {
        index = 0;
        valid = document.checkNesting(target, event.dragObject);
      }

      designer.createLocation({
        target: target,
        source: _this.id,
        event: event,
        detail: {
          type: LocationDetailType.Children,
          index: index,
          focus: focus,
          valid: valid
        }
      });
    });
    this.tryScrollAgain = null;
    this.sensing = false;
    this._scrollTarget = void 0;
    this.scroller = void 0;
    this._sensorAvailable = false;
    this._shell = null;
    makeObservable(this);
    this.editor = editor;
    this.at = at;
    var inited = false;

    var setup = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        var designer;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!inited) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return", false);

              case 2:
                inited = true;
                _context.next = 5;
                return editor.onceGot('designer');

              case 5:
                designer = _context.sent;

                _this.setupDesigner(designer);

              case 7:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function setup() {
        return _ref.apply(this, arguments);
      };
    }();

    if (at === Backup) {
      setup();
    } else {
      editor.on('skeleton.panel.show', function (key) {
        if (key === at) {
          setup();
          _this._visible = true;
        }
      });
      editor.on('skeleton.panel.hide', function (key) {
        if (key === at) {
          _this._visible = false;
        }
      });
    }
  }
  /**
   * @see ISensor
   */


  var _proto = OutlineMain.prototype;

  _proto.fixEvent = function fixEvent(e) {
    var _e$originalEvent$view, _this$_designer;

    if (e.fixed) {
      return e;
    }

    var notMyEvent = ((_e$originalEvent$view = e.originalEvent.view) === null || _e$originalEvent$view === void 0 ? void 0 : _e$originalEvent$view.document) !== document;

    if (!e.target || notMyEvent) {
      e.target = document.elementFromPoint(e.canvasX, e.canvasY);
    } // documentModel : 目标文档


    e.documentModel = (_this$_designer = this._designer) === null || _this$_designer === void 0 ? void 0 : _this$_designer.currentDocument; // 事件已订正

    e.fixed = true;
    return e;
  };

  /**
   * @see ISensor
   */
  _proto.locate = function locate(e) {
    var _this$scroller, _this$_master;

    this.sensing = true;
    (_this$scroller = this.scroller) === null || _this$scroller === void 0 ? void 0 : _this$scroller.scrolling(e);
    var globalY = e.globalY,
        dragObject = e.dragObject;
    var nodes = dragObject.nodes;
    var tree = (_this$_master = this._master) === null || _this$_master === void 0 ? void 0 : _this$_master.currentTree;

    if (!tree || !tree.root || !this._shell) {
      return null;
    }

    var operationalNodes = nodes === null || nodes === void 0 ? void 0 : nodes.filter(function (node) {
      var _node$componentMeta, _node$componentMeta$g, _node$componentMeta$g2, _node$componentMeta$g3;

      var onMoveHook = (_node$componentMeta = node.componentMeta) === null || _node$componentMeta === void 0 ? void 0 : (_node$componentMeta$g = _node$componentMeta.getMetadata().configure) === null || _node$componentMeta$g === void 0 ? void 0 : (_node$componentMeta$g2 = _node$componentMeta$g.advanced) === null || _node$componentMeta$g2 === void 0 ? void 0 : (_node$componentMeta$g3 = _node$componentMeta$g2.callbacks) === null || _node$componentMeta$g3 === void 0 ? void 0 : _node$componentMeta$g3.onMoveHook;
      var canMove = onMoveHook && typeof onMoveHook === 'function' ? onMoveHook(node) : true;
      return canMove;
    });

    if (!operationalNodes || operationalNodes.length === 0) {
      return;
    }

    var document = tree.document;
    var designer = document.designer;
    var pos = getPosFromEvent(e, this._shell);
    var irect = this.getInsertionRect();
    var originLoc = document.dropLocation;
    var componentMeta = e.dragObject.nodes ? e.dragObject.nodes[0].componentMeta : null;

    if (e.dragObject.type === 'node' && componentMeta && componentMeta.isModal) {
      return designer.createLocation({
        target: document.focusNode,
        detail: {
          type: LocationDetailType.Children,
          index: 0,
          valid: true
        },
        source: this.id,
        event: e
      });
    }

    if (originLoc && (pos && pos === 'unchanged' || irect && globalY >= irect.top && globalY <= irect.bottom)) {
      var _loc = originLoc.clone(e);

      var indented = this.indentTrack.getIndentParent(originLoc, _loc);

      if (indented) {
        var parent = indented[0],
            index = indented[1];

        if (checkRecursion(parent, dragObject)) {
          if (tree.getTreeNode(parent).expanded) {
            this.dwell.reset();
            return designer.createLocation({
              target: parent,
              source: this.id,
              event: e,
              detail: {
                type: LocationDetailType.Children,
                index: index,
                valid: document.checkNesting(parent, e.dragObject)
              }
            });
          }

          originLoc.detail.focus = {
            type: 'node',
            node: parent
          }; // focus try expand go on

          this.dwell.focus(parent, e);
        } else {
          this.dwell.reset();
        } // FIXME: recreate new location

      } else if (originLoc.detail.near) {
        originLoc.detail.near = undefined;
        this.dwell.reset();
      }

      return;
    }

    this.indentTrack.reset();

    if (pos && pos !== 'unchanged') {
      var treeNode = tree.getTreeNodeById(pos.nodeId);

      if (treeNode) {
        var focusSlots = pos.focusSlots;
        var _treeNode = treeNode,
            node = _treeNode.node;

        if (isDragNodeObject(dragObject)) {
          var newNodes = operationalNodes;
          var i = newNodes.length;
          var p = node;

          while (i-- > 0) {
            if (contains(newNodes[i], p)) {
              p = newNodes[i].parent;
            }
          }

          if (p !== node) {
            node = p || document.focusNode;
            treeNode = tree.getTreeNode(node);
            focusSlots = false;
          }
        }

        if (focusSlots) {
          this.dwell.reset();
          return designer.createLocation({
            target: node,
            source: this.id,
            event: e,
            detail: {
              type: LocationDetailType.Children,
              index: null,
              valid: false,
              focus: {
                type: 'slots'
              }
            }
          });
        }

        if (!treeNode.isRoot()) {
          var _loc2 = this.getNear(treeNode, e);

          this.dwell.tryFocus(_loc2);
          return _loc2;
        }
      }
    }

    var loc = this.drillLocate(tree.root, e);
    this.dwell.tryFocus(loc);
    return loc;
  };

  _proto.getNear = function getNear(treeNode, e, index, rect) {
    var document = treeNode.tree.document;
    var designer = document.designer;
    var globalY = e.globalY,
        dragObject = e.dragObject; // TODO: check dragObject is anyData

    var node = treeNode.node,
        expanded = treeNode.expanded;

    if (!rect) {
      rect = this.getTreeNodeRect(treeNode);

      if (!rect) {
        return null;
      }
    }

    if (index == null) {
      index = node.index;
    }

    if (node.isSlot()) {
      // 是个插槽根节点
      if (!treeNode.isContainer() && !treeNode.hasSlots()) {
        return designer.createLocation({
          target: node.parent,
          source: this.id,
          event: e,
          detail: {
            type: LocationDetailType.Children,
            index: null,
            near: {
              node: node,
              pos: 'replace'
            },
            valid: true // TODO: future validation the slot limit

          }
        });
      }

      var loc1 = this.drillLocate(treeNode, e);

      if (loc1) {
        return loc1;
      }

      return designer.createLocation({
        target: node.parent,
        source: this.id,
        event: e,
        detail: {
          type: LocationDetailType.Children,
          index: null,
          valid: false,
          focus: {
            type: 'slots'
          }
        }
      });
    }

    var focusNode; // focus

    if (!expanded && (treeNode.isContainer() || treeNode.hasSlots())) {
      focusNode = node;
    } // before


    var titleRect = this.getTreeTitleRect(treeNode) || rect;

    if (globalY < titleRect.top + titleRect.height / 2) {
      return designer.createLocation({
        target: node.parent,
        source: this.id,
        event: e,
        detail: {
          type: LocationDetailType.Children,
          index: index,
          valid: document.checkNesting(node.parent, dragObject),
          near: {
            node: node,
            pos: 'before'
          },
          focus: checkRecursion(focusNode, dragObject) ? {
            type: 'node',
            node: focusNode
          } : undefined
        }
      });
    }

    if (globalY > titleRect.bottom) {
      focusNode = undefined;
    }

    if (expanded) {
      // drill
      var loc = this.drillLocate(treeNode, e);

      if (loc) {
        return loc;
      }
    } // after


    return designer.createLocation({
      target: node.parent,
      source: this.id,
      event: e,
      detail: {
        type: LocationDetailType.Children,
        index: index + 1,
        valid: document.checkNesting(node.parent, dragObject),
        near: {
          node: node,
          pos: 'after'
        },
        focus: checkRecursion(focusNode, dragObject) ? {
          type: 'node',
          node: focusNode
        } : undefined
      }
    });
  };

  _proto.drillLocate = function drillLocate(treeNode, e) {
    var document = treeNode.tree.document;
    var designer = document.designer;
    var dragObject = e.dragObject,
        globalY = e.globalY;

    if (!checkRecursion(treeNode.node, dragObject)) {
      return null;
    }

    if (isDragAnyObject(dragObject)) {
      // TODO: future
      return null;
    }

    var container = treeNode.node;
    var detail = {
      type: LocationDetailType.Children
    };
    var locationData = {
      target: container,
      detail: detail,
      source: this.id,
      event: e
    };
    var isSlotContainer = treeNode.hasSlots();
    var isContainer = treeNode.isContainer();

    if (container.isSlot() && !treeNode.expanded) {
      // 未展开，直接定位到内部第一个节点
      if (isSlotContainer) {
        detail.index = null;
        detail.focus = {
          type: 'slots'
        };
        detail.valid = false;
      } else {
        detail.index = 0;
        detail.valid = document.checkNesting(container, dragObject);
      }
    }

    var items = null;
    var slotsRect;
    var focusSlots = false; // isSlotContainer

    if (isSlotContainer) {
      slotsRect = this.getTreeSlotsRect(treeNode);

      if (slotsRect) {
        if (globalY <= slotsRect.bottom) {
          focusSlots = true;
          items = treeNode.slots;
        } else if (!isContainer) {
          // 不在 slots 范围，又不是 container 的情况，高亮 slots 区
          detail.index = null;
          detail.focus = {
            type: 'slots'
          };
          detail.valid = false;
          return designer.createLocation(locationData);
        }
      }
    }

    if (!items && isContainer) {
      items = treeNode.children;
    }

    if (!items) {
      return null;
    }

    var l = items.length;
    var index = 0;
    var before = l < 1;
    var current;
    var currentIndex = index;

    for (; index < l; index++) {
      current = items[index];
      currentIndex = index;
      var rect = this.getTreeNodeRect(current);

      if (!rect) {
        continue;
      } // rect


      if (globalY < rect.top) {
        before = true;
        break;
      }

      if (globalY > rect.bottom) {
        continue;
      }

      var loc = this.getNear(current, e, index, rect);

      if (loc) {
        return loc;
      }
    }

    if (focusSlots) {
      detail.focus = {
        type: 'slots'
      };
      detail.valid = false;
      detail.index = null;
    } else {
      if (current) {
        detail.index = before ? currentIndex : currentIndex + 1;
        detail.near = {
          node: current.node,
          pos: before ? 'before' : 'after'
        };
      } else {
        detail.index = l;
      }

      detail.valid = document.checkNesting(container, dragObject);
    }

    return designer.createLocation(locationData);
  }
  /**
   * @see ISensor
   */
  ;

  _proto.isEnter = function isEnter(e) {
    if (!this._shell) {
      return false;
    }

    var rect = this._shell.getBoundingClientRect();

    return e.globalY >= rect.top && e.globalY <= rect.bottom && e.globalX >= rect.left && e.globalX <= rect.right;
  };

  /**
   * @see IScrollBoard
   */
  _proto.scrollToNode = function scrollToNode(treeNode, detail, tryTimes) {
    var _this2 = this;

    if (tryTimes === void 0) {
      tryTimes = 0;
    }

    if (tryTimes < 1 && this.tryScrollAgain) {
      window.cancelIdleCallback(this.tryScrollAgain);
      this.tryScrollAgain = null;
    }

    if (this.sensing || !this.bounds || !this.scroller || !this.scrollTarget) {
      // is a active sensor
      return;
    }

    var rect;

    if (detail && isLocationChildrenDetail(detail)) {
      rect = this.getInsertionRect();
    } else {
      rect = this.getTreeNodeRect(treeNode);
    }

    if (!rect) {
      if (tryTimes < 3) {
        this.tryScrollAgain = window.requestIdleCallback(function () {
          return _this2.scrollToNode(treeNode, detail, tryTimes + 1);
        });
      }

      return;
    }

    var _this$scrollTarget = this.scrollTarget,
        scrollHeight = _this$scrollTarget.scrollHeight,
        scrollTop = _this$scrollTarget.top;
    var _this$bounds = this.bounds,
        height = _this$bounds.height,
        top = _this$bounds.top,
        bottom = _this$bounds.bottom;

    if (rect.top < top || rect.bottom > bottom) {
      var opt = {};
      opt.top = Math.min(rect.top + rect.height / 2 + scrollTop - top - height / 2, scrollHeight - height);

      if (rect.height >= height) {
        opt.top = Math.min(scrollTop + rect.top - top, opt.top);
      }

      this.scroller.scrollTo(opt);
    } // make tail scroll be sure


    if (tryTimes < 4) {
      this.tryScrollAgain = window.requestIdleCallback(function () {
        return _this2.scrollToNode(treeNode, detail, 4);
      });
    }
  };

  /**
   * @see ISensor
   */
  _proto.deactiveSensor = function deactiveSensor() {
    var _this$scroller2;

    this.sensing = false;
    (_this$scroller2 = this.scroller) === null || _this$scroller2 === void 0 ? void 0 : _this$scroller2.cancel();
    this.dwell.reset();
    this.indentTrack.reset();
  }
  /**
   * @see IScrollable
   */
  ;

  _proto.setupDesigner = function setupDesigner(designer) {
    this._designer = designer;
    this._master = getTreeMaster(designer);

    this._master.addBoard(this);

    designer.dragon.addSensor(this);
    this.scroller = designer.createScroller(this);
  };

  _proto.purge = function purge() {
    var _this$_designer2, _this$_master2;

    (_this$_designer2 = this._designer) === null || _this$_designer2 === void 0 ? void 0 : _this$_designer2.dragon.removeSensor(this);
    (_this$_master2 = this._master) === null || _this$_master2 === void 0 ? void 0 : _this$_master2.removeBoard(this); // todo purge treeMaster if needed
  };

  _proto.mount = function mount(shell) {
    if (this._shell === shell) {
      return;
    }

    this._shell = shell;

    if (shell) {
      this._scrollTarget = new ScrollTarget(shell);
      this._sensorAvailable = true;
    } else {
      this._scrollTarget = undefined;
      this._sensorAvailable = false;
    }
  };

  _proto.getInsertionRect = function getInsertionRect() {
    var _this$_shell$querySel;

    if (!this._shell) {
      return undefined;
    }

    return (_this$_shell$querySel = this._shell.querySelector('.insertion')) === null || _this$_shell$querySel === void 0 ? void 0 : _this$_shell$querySel.getBoundingClientRect();
  };

  _proto.getTreeNodeRect = function getTreeNodeRect(treeNode) {
    var _this$_shell$querySel2;

    if (!this._shell) {
      return undefined;
    }

    return (_this$_shell$querySel2 = this._shell.querySelector(".tree-node[data-id=\"" + treeNode.id + "\"]")) === null || _this$_shell$querySel2 === void 0 ? void 0 : _this$_shell$querySel2.getBoundingClientRect();
  };

  _proto.getTreeTitleRect = function getTreeTitleRect(treeNode) {
    var _this$_shell$querySel3;

    if (!this._shell) {
      return undefined;
    }

    return (_this$_shell$querySel3 = this._shell.querySelector(".tree-node-title[data-id=\"" + treeNode.id + "\"]")) === null || _this$_shell$querySel3 === void 0 ? void 0 : _this$_shell$querySel3.getBoundingClientRect();
  };

  _proto.getTreeSlotsRect = function getTreeSlotsRect(treeNode) {
    var _this$_shell$querySel4;

    if (!this._shell) {
      return undefined;
    }

    return (_this$_shell$querySel4 = this._shell.querySelector(".tree-node-slots[data-id=\"" + treeNode.id + "\"]")) === null || _this$_shell$querySel4 === void 0 ? void 0 : _this$_shell$querySel4.getBoundingClientRect();
  };

  _createClass(OutlineMain, [{
    key: "master",
    get: function get() {
      return this._master;
    }
  }, {
    key: "currentTree",
    get: function get() {
      var _this$_master3;

      return (_this$_master3 = this._master) === null || _this$_master3 === void 0 ? void 0 : _this$_master3.currentTree;
    }
  }, {
    key: "visible",
    get: function get() {
      return this._visible;
    }
  }, {
    key: "bounds",
    get: function get() {
      if (!this._shell) {
        return null;
      }

      return this._shell.getBoundingClientRect();
    }
  }, {
    key: "scrollTarget",
    get:
    /**
     * @see IScrollable
     */
    function get() {
      return this._scrollTarget;
    }
  }, {
    key: "sensorAvailable",
    get:
    /**
     * @see ISensor
     */
    function get() {
      return this._sensorAvailable;
    }
  }]);

  return OutlineMain;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "_master", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class.prototype, "currentTree", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "currentTree"), _class.prototype), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, "_visible", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
})), _class));

function checkRecursion(parent, dragObject) {
  if (!parent) {
    return false;
  }

  if (isDragNodeObject(dragObject)) {
    var nodes = dragObject.nodes;

    if (nodes.some(function (node) {
      return node.contains(parent);
    })) {
      return false;
    }
  }

  return true;
}

function getPosFromEvent(_ref2, stop) {
  var target = _ref2.target;

  if (!target || !stop.contains(target)) {
    return null;
  }

  if (target.matches('.insertion')) {
    return 'unchanged';
  }

  target = target.closest('[data-id]');

  if (!target || !stop.contains(target)) {
    return null;
  }

  var nodeId = target.dataset.id;
  return {
    focusSlots: target.matches('.tree-node-slots'),
    nodeId: nodeId
  };
}