import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _createClass from "@babel/runtime/helpers/createClass";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _class, _descriptor;

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (it) return (it = it.call(o)).next.bind(it); if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { computed, makeObservable, obx } from '@alilc/lowcode-editor-core';
import { isLocationChildrenDetail } from '@alilc/lowcode-designer';
import { Tree } from './tree';
import { Backup } from './views/backup-pane';
export var TreeMaster = (_dec = obx.shallow, (_class = /*#__PURE__*/function () {
  function TreeMaster(designer) {
    var _this = this;

    this.designer = void 0;

    _initializerDefineProperty(this, "boards", _descriptor, this);

    this.treeMap = new Map();
    makeObservable(this);
    this.designer = designer;
    var startTime;
    designer.dragon.onDragstart(function () {
      startTime = Date.now() / 1000; // needs?

      _this.toVision();
    });
    designer.activeTracker.onChange(function (_ref) {
      var node = _ref.node,
          detail = _ref.detail;
      var tree = _this.currentTree;

      if (!tree || node.document !== tree.document) {
        return;
      }

      var treeNode = tree.getTreeNode(node);

      if (detail && isLocationChildrenDetail(detail)) {
        treeNode.expand(true);
      } else {
        treeNode.expandParents();
      }

      _this.boards.forEach(function (board) {
        board.scrollToNode(treeNode, detail);
      });
    });
    designer.dragon.onDragend(function () {
      var _designer$currentSele;

      var endTime = Date.now() / 1000;
      var editor = designer === null || designer === void 0 ? void 0 : designer.editor;
      var nodes = (_designer$currentSele = designer.currentSelection) === null || _designer$currentSele === void 0 ? void 0 : _designer$currentSele.getNodes();
      editor === null || editor === void 0 ? void 0 : editor.emit('outlinePane.drag', {
        selected: nodes === null || nodes === void 0 ? void 0 : nodes.map(function (n) {
          var _n$componentMeta, _n$componentMeta2;

          if (!n) {
            return;
          }

          var npm = n === null || n === void 0 ? void 0 : (_n$componentMeta = n.componentMeta) === null || _n$componentMeta === void 0 ? void 0 : _n$componentMeta.npm;
          return [npm === null || npm === void 0 ? void 0 : npm["package"], npm === null || npm === void 0 ? void 0 : npm.componentName].filter(function (item) {
            return !!item;
          }).join('-') || (n === null || n === void 0 ? void 0 : (_n$componentMeta2 = n.componentMeta) === null || _n$componentMeta2 === void 0 ? void 0 : _n$componentMeta2.componentName);
        }).join('&'),
        time: (endTime - startTime).toFixed(2)
      });
    });
    designer.editor.on('designer.document.remove', function (_ref2) {
      var id = _ref2.id;

      _this.treeMap["delete"](id);
    });
  }

  var _proto = TreeMaster.prototype;

  _proto.toVision = function toVision() {
    var tree = this.currentTree;

    if (tree) {
      tree.document.selection.getTopNodes().forEach(function (node) {
        tree.getTreeNode(node).setExpanded(false);
      });
    }
  };

  _proto.addBoard = function addBoard(board) {
    this.boards.add(board);
  };

  _proto.removeBoard = function removeBoard(board) {
    this.boards["delete"](board);
  };

  _proto.hasVisibleTreeBoard = function hasVisibleTreeBoard() {
    for (var _iterator = _createForOfIteratorHelperLoose(this.boards), _step; !(_step = _iterator()).done;) {
      var item = _step.value;

      if (item.visible && item.at !== Backup) {
        return true;
      }
    }

    return false;
  };

  _proto.purge = function purge() {// todo others purge
  };

  _createClass(TreeMaster, [{
    key: "currentTree",
    get: function get() {
      var _this$designer;

      var doc = (_this$designer = this.designer) === null || _this$designer === void 0 ? void 0 : _this$designer.currentDocument;

      if (doc) {
        var id = doc.id;

        if (this.treeMap.has(id)) {
          return this.treeMap.get(id);
        }

        var tree = new Tree(doc);
        this.treeMap.set(id, tree);
        return tree;
      }

      return null;
    }
  }]);

  return TreeMaster;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, "boards", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return new Set();
  }
}), _applyDecoratedDescriptor(_class.prototype, "currentTree", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "currentTree"), _class.prototype)), _class));
var mastersMap = new Map();
export function getTreeMaster(designer) {
  var master = mastersMap.get(designer);

  if (!master) {
    master = new TreeMaster(designer);
    mastersMap.set(designer, master);
  }

  return master;
}