import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _createClass from "@babel/runtime/helpers/createClass";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";

var _dec, _dec2, _dec3, _class, _descriptor, _descriptor2, _descriptor3;

import { isI18nData } from '@alilc/lowcode-types';
import { computed, obx, intl, makeObservable, action } from '@alilc/lowcode-editor-core';
import { isLocationChildrenDetail } from '@alilc/lowcode-designer';
var TreeNode = (_dec = obx.ref, _dec2 = obx.ref, _dec3 = obx.ref, (_class = /*#__PURE__*/function () {
  var _proto = TreeNode.prototype;

  _proto.isRoot = function isRoot(includeOriginalRoot) {
    if (includeOriginalRoot === void 0) {
      includeOriginalRoot = false;
    }

    return this.tree.root === this || includeOriginalRoot && this.tree.document.rootNode === this.node;
  }
  /**
   * 是否是响应投放区
   */
  ;

  _proto.isResponseDropping = function isResponseDropping() {
    var loc = this.node.document.dropLocation;

    if (!loc) {
      return false;
    }

    return loc.target === this.node;
  };

  _proto.isFocusingNode = function isFocusingNode() {
    var _loc$detail$focus;

    var loc = this.node.document.dropLocation;

    if (!loc) {
      return false;
    }

    return isLocationChildrenDetail(loc.detail) && ((_loc$detail$focus = loc.detail.focus) === null || _loc$detail$focus === void 0 ? void 0 : _loc$detail$focus.type) === 'node' && loc.detail.focus.node === this.node;
  }
  /**
   * 默认为折叠状态
   * 在初始化根节点时，设置为展开状态
   */
  ;

  _proto.setExpanded = function setExpanded(value) {
    this._expanded = value;
  };

  _proto.setHidden = function setHidden(flag) {
    if (this.node.conditionGroup) {
      return;
    }

    this.node.setVisible(!flag);
  };

  _proto.setLocked = function setLocked(flag) {
    this.node.lock(flag);
  };

  _proto.setTitleLabel = function setTitleLabel(label) {
    var origLabel = this.titleLabel;

    if (label === origLabel) {
      return;
    }

    if (label === '') {
      var _this$node$getExtraPr;

      (_this$node$getExtraPr = this.node.getExtraProp('title', false)) === null || _this$node$getExtraPr === void 0 ? void 0 : _this$node$getExtraPr.remove();
    } else {
      var _this$node$getExtraPr2;

      (_this$node$getExtraPr2 = this.node.getExtraProp('title', true)) === null || _this$node$getExtraPr2 === void 0 ? void 0 : _this$node$getExtraPr2.setValue(label);
    }
  };

  /**
   * 是否是容器，允许子节点拖入
   */
  _proto.isContainer = function isContainer() {
    return this.node.isContainer();
  }
  /**
   * 判断是否有"插槽"
   */
  ;

  _proto.hasSlots = function hasSlots() {
    return this.node.hasSlots();
  };

  _proto.hasChildren = function hasChildren() {
    var _this$node$children;

    return !!(this.isContainer() && (_this$node$children = this.node.children) !== null && _this$node$children !== void 0 && _this$node$children.notEmpty());
  };

  _proto.select = function select(isMulti) {
    var node = this.node;
    var selection = node.document.selection;

    if (isMulti) {
      selection.add(node.id);
    } else {
      selection.select(node.id);
    }
  }
  /**
   * 展开节点，支持依次展开父节点
   */
  ;

  _proto.expand = function expand(tryExpandParents) {
    if (tryExpandParents === void 0) {
      tryExpandParents = false;
    }

    // 这边不能直接使用 expanded，需要额外判断是否可以展开
    // 如果只使用 expanded，会漏掉不可以展开的情况，即在不可以展开的情况下，会触发展开
    if (this.expandable && !this._expanded) {
      this.setExpanded(true);
    }

    if (tryExpandParents) {
      this.expandParents();
    }
  };

  _proto.expandParents = function expandParents() {
    var p = this.node.parent;

    while (p) {
      this.tree.getTreeNode(p).setExpanded(true);
      p = p.parent;
    }
  };

  function TreeNode(tree, node) {
    _initializerDefineProperty(this, "_expanded", _descriptor, this);

    this.designer = void 0;
    this.document = void 0;

    _initializerDefineProperty(this, "_node", _descriptor2, this);

    this.tree = void 0;

    _initializerDefineProperty(this, "_filterResult", _descriptor3, this);

    makeObservable(this);
    this.tree = tree;
    this.document = node.document;
    this.designer = this.document.designer;
    this._node = node;
  }

  _proto.setNode = function setNode(node) {
    if (this._node !== node) {
      this._node = node;
    }
  };

  _proto.setFilterReult = function setFilterReult(val) {
    this._filterResult = val;
  };

  _createClass(TreeNode, [{
    key: "id",
    get: function get() {
      return this.node.id;
    }
    /**
     * 是否可以展开
     */

  }, {
    key: "expandable",
    get: function get() {
      var _this$dropDetail;

      if (this.locked) return false;
      return this.hasChildren() || this.hasSlots() || ((_this$dropDetail = this.dropDetail) === null || _this$dropDetail === void 0 ? void 0 : _this$dropDetail.index) != null;
    }
    /**
     * 插入"线"位置信息
     */

  }, {
    key: "dropDetail",
    get: function get() {
      var loc = this.node.document.dropLocation;
      return loc && this.isResponseDropping() && isLocationChildrenDetail(loc.detail) ? loc.detail : null;
    }
  }, {
    key: "depth",
    get: function get() {
      return this.node.zLevel;
    }
  }, {
    key: "expanded",
    get: function get() {
      return this.isRoot(true) || this.expandable && this._expanded;
    }
  }, {
    key: "detecting",
    get: function get() {
      return this.designer.detecting.current === this.node;
    }
  }, {
    key: "hidden",
    get: function get() {
      var cv = this.node.isConditionalVisible();

      if (cv == null) {
        return !this.node.getVisible();
      }

      return !cv;
    }
  }, {
    key: "locked",
    get: function get() {
      return this.node.isLocked;
    }
  }, {
    key: "selected",
    get: function get() {
      // TODO: check is dragging
      var selection = this.document.selection;
      return selection.has(this.node.id);
    }
  }, {
    key: "title",
    get: function get() {
      return this.node.title;
    }
  }, {
    key: "titleLabel",
    get: function get() {
      var title = this.title;

      if (!title) {
        return '';
      }

      if (title.label) {
        title = title.label;
      }

      if (typeof title === 'string') {
        return title;
      }

      if (isI18nData(title)) {
        return intl(title);
      }

      return this.node.componentName;
    }
  }, {
    key: "icon",
    get: function get() {
      return this.node.componentMeta.icon;
    }
  }, {
    key: "parent",
    get: function get() {
      var parent = this.node.parent;

      if (parent) {
        return this.tree.getTreeNode(parent);
      }

      return null;
    }
  }, {
    key: "slots",
    get: function get() {
      var _this = this;

      // todo: shallowEqual
      return this.node.slots.map(function (node) {
        return _this.tree.getTreeNode(node);
      });
    }
  }, {
    key: "children",
    get: function get() {
      var _this$node$children2,
          _this2 = this;

      return ((_this$node$children2 = this.node.children) === null || _this$node$children2 === void 0 ? void 0 : _this$node$children2.map(function (node) {
        return _this2.tree.getTreeNode(node);
      })) || null;
    }
  }, {
    key: "node",
    get: function get() {
      return this._node;
    }
  }, {
    key: "filterReult",
    get: function get() {
      return this._filterResult;
    }
  }]);

  return TreeNode;
}(), (_applyDecoratedDescriptor(_class.prototype, "dropDetail", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "dropDetail"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "depth", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "depth"), _class.prototype), _descriptor = _applyDecoratedDescriptor(_class.prototype, "_expanded", [_dec], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return false;
  }
}), _applyDecoratedDescriptor(_class.prototype, "detecting", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "detecting"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "hidden", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "hidden"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "locked", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "locked"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "selected", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "selected"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "title", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "title"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "titleLabel", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "titleLabel"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "parent", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "parent"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "slots", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "slots"), _class.prototype), _applyDecoratedDescriptor(_class.prototype, "children", [computed], Object.getOwnPropertyDescriptor(_class.prototype, "children"), _class.prototype), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, "_node", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _applyDecoratedDescriptor(_class.prototype, "setNode", [action], Object.getOwnPropertyDescriptor(_class.prototype, "setNode"), _class.prototype), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, "_filterResult", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: function initializer() {
    return {
      filterWorking: false,
      matchChild: false,
      matchSelf: false,
      keywords: ''
    };
  }
}), _applyDecoratedDescriptor(_class.prototype, "setFilterReult", [action], Object.getOwnPropertyDescriptor(_class.prototype, "setFilterReult"), _class.prototype)), _class));
export { TreeNode as default };