import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _class;

import React, { Component } from 'react';
import { observer, globalContext } from '@alilc/lowcode-editor-core';
import { intl } from '../locale';
import { OutlineMain } from '../main';
import TreeView from './tree';
import './style.less';
import Filter from './filter';
export var OutlinePane = observer(_class = /*#__PURE__*/function (_Component) {
  _inheritsLoose(OutlinePane, _Component);

  function OutlinePane() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.main = new OutlineMain(globalContext.get('editor'), _this.props.config.name || _this.props.config.pluginKey);
    return _this;
  }

  var _proto = OutlinePane.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.main.purge();
  };

  _proto.render = function render() {
    var _this2 = this;

    var tree = this.main.currentTree;

    if (!tree) {
      return /*#__PURE__*/React.createElement("div", {
        className: "lc-outline-pane"
      }, /*#__PURE__*/React.createElement("p", {
        className: "lc-outline-notice"
      }, intl('Initializing')));
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "lc-outline-pane"
    }, /*#__PURE__*/React.createElement(Filter, {
      tree: tree
    }), /*#__PURE__*/React.createElement("div", {
      ref: function ref(shell) {
        return _this2.main.mount(shell);
      },
      className: "lc-outline-tree-container"
    }, /*#__PURE__*/React.createElement(TreeView, {
      key: tree.id,
      tree: tree
    })));
  };

  return OutlinePane;
}(Component)) || _class;