import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _class, _class3;

import { Component } from 'react';
import classNames from 'classnames';
import { observer } from '@alilc/lowcode-editor-core';
import TreeTitle from './tree-title';
import TreeBranches from './tree-branches';
import { IconEyeClose } from '../icons/eye-close';

var ModalTreeNodeView = observer(_class = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ModalTreeNodeView, _Component);

  function ModalTreeNodeView(props) {
    var _this;

    _this = _Component.call(this, props) || this; // 模态管理对象

    _this.modalNodesManager = void 0;
    _this.modalNodesManager = props.treeNode.document.modalNodesManager;
    return _this;
  }

  var _proto = ModalTreeNodeView.prototype;

  _proto.hideAllNodes = function hideAllNodes() {
    this.modalNodesManager.hideModalNodes();
  };

  _proto.render = function render() {
    var _rootTreeNode$childre;

    var treeNode = this.props.treeNode; // 当指定了新的根节点时，要从原始的根节点去获取模态节点

    var rootTreeNode = treeNode.tree.getTreeNode(treeNode.document.rootNode);
    var modalNodes = (_rootTreeNode$childre = rootTreeNode.children) === null || _rootTreeNode$childre === void 0 ? void 0 : _rootTreeNode$childre.filter(function (item) {
      return item.node.componentMeta.isModal;
    });

    if (!modalNodes || modalNodes.length === 0) {
      return null;
    }

    var hasVisibleModalNode = !!this.modalNodesManager.getVisibleModalNode();
    return /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal"
    }, /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal-title"
    }, /*#__PURE__*/React.createElement("span", null, "\u6A21\u6001\u89C6\u56FE\u5C42"), /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal-title-visible-icon",
      onClick: this.hideAllNodes.bind(this)
    }, hasVisibleModalNode ? /*#__PURE__*/React.createElement(IconEyeClose, null) : null)), /*#__PURE__*/React.createElement("div", {
      className: "tree-pane-modal-content"
    }, /*#__PURE__*/React.createElement(TreeBranches, {
      treeNode: rootTreeNode,
      isModal: true
    })));
  };

  return ModalTreeNodeView;
}(Component)) || _class;

var RootTreeNodeView = observer(_class3 = /*#__PURE__*/function (_Component2) {
  _inheritsLoose(RootTreeNodeView, _Component2);

  function RootTreeNodeView() {
    return _Component2.apply(this, arguments) || this;
  }

  var _proto2 = RootTreeNodeView.prototype;

  _proto2.render = function render() {
    var _treeNode$dropDetail;

    var treeNode = this.props.treeNode;
    var className = classNames('tree-node', {
      // 是否展开
      expanded: treeNode.expanded,
      // 是否悬停中
      detecting: treeNode.detecting,
      // 是否选中的
      selected: treeNode.selected,
      // 是否隐藏的
      hidden: treeNode.hidden,
      // 是否忽略的
      // ignored: treeNode.ignored,
      // 是否锁定的
      locked: treeNode.locked,
      // 是否投放响应
      dropping: ((_treeNode$dropDetail = treeNode.dropDetail) === null || _treeNode$dropDetail === void 0 ? void 0 : _treeNode$dropDetail.index) != null,
      'is-root': treeNode.isRoot(),
      'condition-flow': treeNode.node.conditionGroup != null,
      highlight: treeNode.isFocusingNode()
    });
    return /*#__PURE__*/React.createElement("div", {
      className: className,
      "data-id": treeNode.id
    }, /*#__PURE__*/React.createElement(TreeTitle, {
      treeNode: treeNode
    }), /*#__PURE__*/React.createElement(ModalTreeNodeView, {
      treeNode: treeNode
    }), /*#__PURE__*/React.createElement(TreeBranches, {
      treeNode: treeNode
    }));
  };

  return RootTreeNodeView;
}(Component)) || _class3;

export { RootTreeNodeView as default };