import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _class, _class2, _class3;

import { Component } from 'react';
import classNames from 'classnames';
import { observer, Title } from '@alilc/lowcode-editor-core';
import TreeNodeView from './tree-node';
import { intlNode } from '../locale';

var TreeBranches = observer(_class3 = /*#__PURE__*/function (_Component3) {
  _inheritsLoose(TreeBranches, _Component3);

  function TreeBranches() {
    return _Component3.apply(this, arguments) || this;
  }

  var _proto3 = TreeBranches.prototype;

  _proto3.render = function render() {
    var _this$props2 = this.props,
        treeNode = _this$props2.treeNode,
        isModal = _this$props2.isModal;
    var expanded = treeNode.expanded;
    var _treeNode$filterReult2 = treeNode.filterReult,
        filterWorking = _treeNode$filterReult2.filterWorking,
        matchChild = _treeNode$filterReult2.matchChild; // 条件过滤生效时，如果命中了子节点，需要将该节点展开

    var expandInFilterResult = filterWorking && matchChild;

    if (!expandInFilterResult && !expanded) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "tree-node-branches"
    }, !isModal && /*#__PURE__*/React.createElement(TreeNodeSlots, {
      treeNode: treeNode
    }), /*#__PURE__*/React.createElement(TreeNodeChildren, {
      treeNode: treeNode,
      isModal: isModal || false
    }));
  };

  return TreeBranches;
}(Component)) || _class3;

export { TreeBranches as default };

var TreeNodeChildren = observer(_class = /*#__PURE__*/function (_Component) {
  _inheritsLoose(TreeNodeChildren, _Component);

  function TreeNodeChildren() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TreeNodeChildren.prototype;

  _proto.render = function render() {
    var _treeNode$children, _treeNode$children2;

    var _this$props = this.props,
        treeNode = _this$props.treeNode,
        isModal = _this$props.isModal;
    var children = [];
    var groupContents = [];
    var currentGrp;
    var _treeNode$filterReult = treeNode.filterReult,
        filterWorking = _treeNode$filterReult.filterWorking,
        matchSelf = _treeNode$filterReult.matchSelf,
        keywords = _treeNode$filterReult.keywords;

    var endGroup = function endGroup() {
      if (groupContents.length > 0) {
        children.push( /*#__PURE__*/React.createElement("div", {
          key: currentGrp.id,
          className: "condition-group-container",
          "data-id": currentGrp.firstNode.id
        }, /*#__PURE__*/React.createElement("div", {
          className: "condition-group-title"
        }, /*#__PURE__*/React.createElement(Title, {
          title: currentGrp.title,
          match: filterWorking && matchSelf,
          keywords: keywords
        })), groupContents));
        groupContents = [];
      }
    };

    var dropDetail = treeNode.dropDetail;
    var dropIndex = dropDetail === null || dropDetail === void 0 ? void 0 : dropDetail.index;
    var insertion = /*#__PURE__*/React.createElement("div", {
      key: "insertion",
      className: classNames('insertion', {
        invalid: (dropDetail === null || dropDetail === void 0 ? void 0 : dropDetail.valid) === false
      })
    });
    (_treeNode$children = treeNode.children) === null || _treeNode$children === void 0 ? void 0 : _treeNode$children.forEach(function (child, index) {
      var childIsModal = child.node.componentMeta.isModal || false;

      if (isModal != childIsModal) {
        return;
      }

      var conditionGroup = child.node.conditionGroup;

      if (conditionGroup !== currentGrp) {
        endGroup();
      }

      if (conditionGroup) {
        currentGrp = conditionGroup;

        if (index === dropIndex) {
          if (groupContents.length > 0) {
            groupContents.push(insertion);
          } else {
            children.push(insertion);
          }
        }

        groupContents.push( /*#__PURE__*/React.createElement(TreeNodeView, {
          key: child.id,
          treeNode: child,
          isModal: isModal
        }));
      } else {
        if (index === dropIndex) {
          children.push(insertion);
        }

        children.push( /*#__PURE__*/React.createElement(TreeNodeView, {
          key: child.id,
          treeNode: child,
          isModal: isModal
        }));
      }
    });
    endGroup();
    var length = ((_treeNode$children2 = treeNode.children) === null || _treeNode$children2 === void 0 ? void 0 : _treeNode$children2.length) || 0;

    if (dropIndex != null && dropIndex >= length) {
      children.push(insertion);
    }

    return /*#__PURE__*/React.createElement("div", {
      className: "tree-node-children"
    }, children);
  };

  return TreeNodeChildren;
}(Component)) || _class;

var TreeNodeSlots = observer(_class2 = /*#__PURE__*/function (_Component2) {
  _inheritsLoose(TreeNodeSlots, _Component2);

  function TreeNodeSlots() {
    return _Component2.apply(this, arguments) || this;
  }

  var _proto2 = TreeNodeSlots.prototype;

  _proto2.render = function render() {
    var _treeNode$dropDetail, _treeNode$dropDetail$;

    var treeNode = this.props.treeNode;

    if (!treeNode.hasSlots()) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: classNames('tree-node-slots', {
        'insertion-at-slots': ((_treeNode$dropDetail = treeNode.dropDetail) === null || _treeNode$dropDetail === void 0 ? void 0 : (_treeNode$dropDetail$ = _treeNode$dropDetail.focus) === null || _treeNode$dropDetail$ === void 0 ? void 0 : _treeNode$dropDetail$.type) === 'slots'
      }),
      "data-id": treeNode.id
    }, /*#__PURE__*/React.createElement("div", {
      className: "tree-node-slots-title"
    }, /*#__PURE__*/React.createElement(Title, {
      title: {
        type: 'i18n',
        intl: intlNode('Slots')
      }
    })), treeNode.slots.map(function (tnode) {
      return /*#__PURE__*/React.createElement(TreeNodeView, {
        key: tnode.id,
        treeNode: tnode
      });
    }));
  };

  return TreeNodeSlots;
}(Component)) || _class2;