import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";

var _class;

import { Component } from 'react';
import classNames from 'classnames';
import { observer } from '@alilc/lowcode-editor-core';
import TreeTitle from './tree-title';
import TreeBranches from './tree-branches';

var TreeNodeView = observer(_class = /*#__PURE__*/function (_Component) {
  _inheritsLoose(TreeNodeView, _Component);

  function TreeNodeView() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TreeNodeView.prototype;

  _proto.render = function render() {
    var _treeNode$dropDetail;

    var _this$props = this.props,
        treeNode = _this$props.treeNode,
        isModal = _this$props.isModal;
    var className = classNames('tree-node', {
      // 是否展开
      expanded: treeNode.expanded,
      // 是否悬停中
      detecting: treeNode.detecting,
      // 是否选中的
      selected: treeNode.selected,
      // 是否隐藏的
      hidden: treeNode.hidden,
      // 是否忽略的
      // ignored: treeNode.ignored,
      // 是否锁定的
      locked: treeNode.locked,
      // 是否投放响应
      dropping: ((_treeNode$dropDetail = treeNode.dropDetail) === null || _treeNode$dropDetail === void 0 ? void 0 : _treeNode$dropDetail.index) != null,
      'is-root': treeNode.isRoot(),
      'condition-flow': treeNode.node.conditionGroup != null,
      highlight: treeNode.isFocusingNode()
    });
    var _treeNode$filterReult = treeNode.filterReult,
        filterWorking = _treeNode$filterReult.filterWorking,
        matchChild = _treeNode$filterReult.matchChild,
        matchSelf = _treeNode$filterReult.matchSelf; // 条件过滤生效时，如果未命中本节点或子节点，则不展示该节点

    if (filterWorking && !matchChild && !matchSelf) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: className,
      "data-id": treeNode.id
    }, /*#__PURE__*/React.createElement(TreeTitle, {
      treeNode: treeNode,
      isModal: isModal
    }), /*#__PURE__*/React.createElement(TreeBranches, {
      treeNode: treeNode,
      isModal: false
    }));
  };

  return TreeNodeView;
}(Component)) || _class;

export { TreeNodeView as default };