"use strict";

exports.__esModule = true;
exports.IndentTrack = void 0;

var _lowcodeDesigner = require("@alilc/lowcode-designer");

var IndentSensitive = 15;

var IndentTrack = /*#__PURE__*/function () {
  function IndentTrack() {
    this.indentStart = null;
  }

  var _proto = IndentTrack.prototype;

  _proto.reset = function reset() {
    this.indentStart = null;
  };

  _proto.getIndentParent = function getIndentParent(lastLoc, loc) {
    if (lastLoc.target !== loc.target || !(0, _lowcodeDesigner.isLocationChildrenDetail)(lastLoc.detail) || !(0, _lowcodeDesigner.isLocationChildrenDetail)(loc.detail) || lastLoc.source !== loc.source || lastLoc.detail.index !== loc.detail.index || loc.detail.index == null) {
      this.indentStart = null;
      return null;
    }

    if (this.indentStart == null) {
      this.indentStart = lastLoc.event.globalX;
    }

    var delta = loc.event.globalX - this.indentStart;
    var indent = Math.floor(Math.abs(delta) / IndentSensitive);

    if (indent < 1) {
      return null;
    }

    this.indentStart = loc.event.globalX;
    var direction = delta < 0 ? 'left' : 'right';
    var parent = loc.target;
    var index = loc.detail.index;

    if (direction === 'left') {
      if (!parent.parent || index < parent.children.size || parent.isSlot()) {
        return null;
      }

      return [parent.parent, parent.index + 1];
    } else {
      if (index === 0) {
        return null;
      }

      parent = parent.children.get(index - 1);

      if (parent && parent.isContainer()) {
        return [parent, parent.children.size];
      }
    }

    return null;
  };

  return IndentTrack;
}();

exports.IndentTrack = IndentTrack;