import { Designer } from '@alilc/lowcode-designer';
import TreeNode from './tree-node';
import { Tree } from './tree';
export interface ITreeBoard {
    readonly visible: boolean;
    readonly at: string | symbol;
    scrollToNode(treeNode: TreeNode, detail?: any): void;
}
export declare class TreeMaster {
    readonly designer: Designer;
    constructor(designer: Designer);
    private toVision;
    private boards;
    addBoard(board: ITreeBoard): void;
    removeBoard(board: ITreeBoard): void;
    hasVisibleTreeBoard(): boolean;
    purge(): void;
    private treeMap;
    get currentTree(): Tree | null;
}
export declare function getTreeMaster(designer: Designer): TreeMaster;
