"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.OutlinePane = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _locale = require("../locale");

var _main = require("../main");

var _tree = _interopRequireDefault(require("./tree"));

require("./style.less");

var _filter = _interopRequireDefault(require("./filter"));

var _class;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var OutlinePane = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(OutlinePane, _Component);

  function OutlinePane() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.main = new _main.OutlineMain(_lowcodeEditorCore.globalContext.get('editor'), _this.props.config.name || _this.props.config.pluginKey);
    return _this;
  }

  var _proto = OutlinePane.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.main.purge();
  };

  _proto.render = function render() {
    var _this2 = this;

    var tree = this.main.currentTree;

    if (!tree) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "lc-outline-pane"
      }, /*#__PURE__*/_react["default"].createElement("p", {
        className: "lc-outline-notice"
      }, (0, _locale.intl)('Initializing')));
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "lc-outline-pane"
    }, /*#__PURE__*/_react["default"].createElement(_filter["default"], {
      tree: tree
    }), /*#__PURE__*/_react["default"].createElement("div", {
      ref: function ref(shell) {
        return _this2.main.mount(shell);
      },
      className: "lc-outline-tree-container"
    }, /*#__PURE__*/_react["default"].createElement(_tree["default"], {
      key: tree.id,
      tree: tree
    })));
  };

  return OutlinePane;
}(_react.Component)) || _class;

exports.OutlinePane = OutlinePane;