"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = require("react");

var _classnames = _interopRequireDefault(require("classnames"));

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _treeTitle = _interopRequireDefault(require("./tree-title"));

var _treeBranches = _interopRequireDefault(require("./tree-branches"));

var _eyeClose = require("../icons/eye-close");

var _class, _class3;

var ModalTreeNodeView = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ModalTreeNodeView, _Component);

  function ModalTreeNodeView(props) {
    var _this;

    _this = _Component.call(this, props) || this; // 模态管理对象

    _this.modalNodesManager = void 0;
    _this.modalNodesManager = props.treeNode.document.modalNodesManager;
    return _this;
  }

  var _proto = ModalTreeNodeView.prototype;

  _proto.hideAllNodes = function hideAllNodes() {
    this.modalNodesManager.hideModalNodes();
  };

  _proto.render = function render() {
    var _rootTreeNode$childre;

    var treeNode = this.props.treeNode; // 当指定了新的根节点时，要从原始的根节点去获取模态节点

    var rootTreeNode = treeNode.tree.getTreeNode(treeNode.document.rootNode);
    var modalNodes = (_rootTreeNode$childre = rootTreeNode.children) === null || _rootTreeNode$childre === void 0 ? void 0 : _rootTreeNode$childre.filter(function (item) {
      return item.node.componentMeta.isModal;
    });

    if (!modalNodes || modalNodes.length === 0) {
      return null;
    }

    var hasVisibleModalNode = !!this.modalNodesManager.getVisibleModalNode();
    return /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal"
    }, /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal-title"
    }, /*#__PURE__*/React.createElement("span", null, "\u6A21\u6001\u89C6\u56FE\u5C42"), /*#__PURE__*/React.createElement("div", {
      className: "tree-node-modal-title-visible-icon",
      onClick: this.hideAllNodes.bind(this)
    }, hasVisibleModalNode ? /*#__PURE__*/React.createElement(_eyeClose.IconEyeClose, null) : null)), /*#__PURE__*/React.createElement("div", {
      className: "tree-pane-modal-content"
    }, /*#__PURE__*/React.createElement(_treeBranches["default"], {
      treeNode: rootTreeNode,
      isModal: true
    })));
  };

  return ModalTreeNodeView;
}(_react.Component)) || _class;

var RootTreeNodeView = (0, _lowcodeEditorCore.observer)(_class3 = /*#__PURE__*/function (_Component2) {
  (0, _inheritsLoose2["default"])(RootTreeNodeView, _Component2);

  function RootTreeNodeView() {
    return _Component2.apply(this, arguments) || this;
  }

  var _proto2 = RootTreeNodeView.prototype;

  _proto2.render = function render() {
    var _treeNode$dropDetail;

    var treeNode = this.props.treeNode;
    var className = (0, _classnames["default"])('tree-node', {
      // 是否展开
      expanded: treeNode.expanded,
      // 是否悬停中
      detecting: treeNode.detecting,
      // 是否选中的
      selected: treeNode.selected,
      // 是否隐藏的
      hidden: treeNode.hidden,
      // 是否忽略的
      // ignored: treeNode.ignored,
      // 是否锁定的
      locked: treeNode.locked,
      // 是否投放响应
      dropping: ((_treeNode$dropDetail = treeNode.dropDetail) === null || _treeNode$dropDetail === void 0 ? void 0 : _treeNode$dropDetail.index) != null,
      'is-root': treeNode.isRoot(),
      'condition-flow': treeNode.node.conditionGroup != null,
      highlight: treeNode.isFocusingNode()
    });
    return /*#__PURE__*/React.createElement("div", {
      className: className,
      "data-id": treeNode.id
    }, /*#__PURE__*/React.createElement(_treeTitle["default"], {
      treeNode: treeNode
    }), /*#__PURE__*/React.createElement(ModalTreeNodeView, {
      treeNode: treeNode
    }), /*#__PURE__*/React.createElement(_treeBranches["default"], {
      treeNode: treeNode
    }));
  };

  return RootTreeNodeView;
}(_react.Component)) || _class3;

exports["default"] = RootTreeNodeView;