"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = require("react");

var _classnames = _interopRequireDefault(require("classnames"));

var _lowcodeEditorCore = require("@alilc/lowcode-editor-core");

var _treeTitle = _interopRequireDefault(require("./tree-title"));

var _treeBranches = _interopRequireDefault(require("./tree-branches"));

var _class;

var TreeNodeView = (0, _lowcodeEditorCore.observer)(_class = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(TreeNodeView, _Component);

  function TreeNodeView() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TreeNodeView.prototype;

  _proto.render = function render() {
    var _treeNode$dropDetail;

    var _this$props = this.props,
        treeNode = _this$props.treeNode,
        isModal = _this$props.isModal;
    var className = (0, _classnames["default"])('tree-node', {
      // 是否展开
      expanded: treeNode.expanded,
      // 是否悬停中
      detecting: treeNode.detecting,
      // 是否选中的
      selected: treeNode.selected,
      // 是否隐藏的
      hidden: treeNode.hidden,
      // 是否忽略的
      // ignored: treeNode.ignored,
      // 是否锁定的
      locked: treeNode.locked,
      // 是否投放响应
      dropping: ((_treeNode$dropDetail = treeNode.dropDetail) === null || _treeNode$dropDetail === void 0 ? void 0 : _treeNode$dropDetail.index) != null,
      'is-root': treeNode.isRoot(),
      'condition-flow': treeNode.node.conditionGroup != null,
      highlight: treeNode.isFocusingNode()
    });
    var _treeNode$filterReult = treeNode.filterReult,
        filterWorking = _treeNode$filterReult.filterWorking,
        matchChild = _treeNode$filterReult.matchChild,
        matchSelf = _treeNode$filterReult.matchSelf; // 条件过滤生效时，如果未命中本节点或子节点，则不展示该节点

    if (filterWorking && !matchChild && !matchSelf) {
      return null;
    }

    return /*#__PURE__*/React.createElement("div", {
      className: className,
      "data-id": treeNode.id
    }, /*#__PURE__*/React.createElement(_treeTitle["default"], {
      treeNode: treeNode,
      isModal: isModal
    }), /*#__PURE__*/React.createElement(_treeBranches["default"], {
      treeNode: treeNode,
      isModal: false
    }));
  };

  return TreeNodeView;
}(_react.Component)) || _class;

exports["default"] = TreeNodeView;